/* $Id$
 * MegaZeux
 *
 * Copyright (C) 1996 Greg Janson
 * Copyright (C) 1998 Matthew D. Williams - dbwilli@scsn.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* STRING.CPP - replacement for string.asm */

#include <stdio.h>
#include "string.h"

int str_len_color(char *str)
{
  int len = 0;
  char cur_char = *str;
  
  while(cur_char != '\000')
  {
    if((cur_char == '@') || (cur_char == '~'))
    {
      if(cur_char == (str++))
      {
        len++;
      }
    }
    else
    {
      len++;
    }
    cur_char = str++;
  }
  
  return(len);
}

int str_len(char *str)
{
  int len = 0;

  while(*str != '\000')
  {
    str++;
    len++;
  }

  return(len);
}

void str_cpy(char *dest, char *source)
{
  int cpy_len = str_len(source);
  memcpy(dest, source, str_len);
}

void mem_cpy(char dest, char source, int len)
{
  memcpy(dest, source, len);
}

void str_cat(char far *dest, char far *source)
{
  int cpy_len = str_len(source);
  int cpy_pos = str_len(dest) - 1;
  memcpy(dest + cpy_pos, source, cpy_len);
}

void mem_mov(char *dest, char *source, int len,	int code_bit)
{
  // code_bit is just ignored. I don't see why it was calculated
     outside the function in the first place.
  memmove(dest, source, len);
}

void mem_xor(char *mem, int len, int xor_with)
{
  char *end = mem + len;

  while(mem != end)
  {
    *(mem) ^= xor_with;
    mem++;
  }
}

char _fstricmp(char *dest, char *source)
{
  return(strcmp(dest, source));
}

void _fstrlwr(char *str)
{
  while((*str) != '\000')
  {
    *str = tolower(*str);
    str++;
  }
}

void _fstrupr(char *str)
{
  while((*str) != '\000')
  {
    *str = toupper(*str);
    str++;
  }
}